<?php
if (function_exists ("strpbrk") === FALSE)
{ function strpbrk ($str, $chars)
  { for ($i=0; $i<strlen($chars); $i++)
        if (strchr ($str,$chars[$i]) === TRUE)
           { return TRUE; }
    return FALSE;
  }
}

function not_empty ($str)
{ $str = trim ($str);
  if ( !empty ($str) ) 
     { return TRUE; }
  return FALSE;
}

function valid_email ($str)
{ 
  if (!not_empty ($str))
     { return "Spatiu gol"; }
  $pos=strpos ($str,"@");
  if ($pos === FALSE)
     { return "Invalid"; }
  $user=substr ($str,0,$pos);
  $url=substr ($str,$pos+1); 
  if ($user !== FALSE AND strpbrk ($user," \$@#!~%^&*()+=\\|?\;:{}[],'\"") === FALSE AND valid_url($url) == "") 
     { return ""; }
  else 
     { return "Invalid"; }
}

function valid_name ($str)
{ $str = trim ($str);
  if (empty ($str))
     { return "Spatiu gol"; }
  if (strlen ($str) == 1)
     { return "Prea scurt"; }
  
  if (strpbrk ($str,"@#\$!%^*+=\\|?:") !== FALSE) 
     { return "Invalid";}

  return "";
}

function valid_user ($str)
{ if (!not_empty ($str))
     { return "Spatiu gol"; }
  if (strlen ($str) < 3)
     { return "Prea scurt"; }
  return "";
}

function valid_pass ($str)
{ if (empty ($str))
     { return "Spatiu gol"; }
  if (strlen ($str) < 5)
     { return "Prea scurt"; }
  return "";
}

function valid_url ($str)
{ 
  if (!not_empty($str))
     { return "Spatiu gol"; }
  $pos=strpos($str,"://");
  if ($pos !== FALSE)
     { $str2=substr($str,0,$pos);
       if ($pos <=5 AND (strcasecmp ($str2,"http") OR strcasecmp($str2,"https")) ) 
	    { $str = substr ($str,$pos+3); }
	 else
	    { return "Invalid"; }
     }
  if (strcasecmp ($str,"localhost") == 0)
     { return ""; }	 
  $pos=strrpos($str,".");
  if ($pos === FALSE)
     { return "Invalid"; }
  $label=substr ($str,0,$pos); 
  $tld=substr ($str,$pos+1);
  if ($label !== FALSE AND $tld !== FALSE AND strpbrk ($label," @#\$!~%^&*()+=\\|?\;:{}[],'\"") === FALSE AND strpbrk ($tld," @#\$!~%^&*()+=\\|?\;:{}[],.'\"") === FALSE AND strstr ($str,"..") === FALSE AND strlen ($tld)>=2)
     { return ""; }
  else
     { return "Invalid"; }
}

function valid_date ($str)
{
  if (!not_empty($str))
     { return "Spatiu gol"; }
  if (strtotime ($str) === FALSE)
     { return "Invalid"; }
  else
     { return ""; }
}

function valid_textfield ($str)
{
  if (!not_empty($str))
     { return "Spatiu gol"; }
  
  if ( strpbrk ($str,"@#\$!%^*+=\\|?:") ) 
     { return "Invalid";}
    
  return "";
}
   
function valid_numfield ($str)
{
  if (!isset ($str) OR trim ($str) == "")
     { return "Spatiu gol"; }
  if (is_numeric ($str) === TRUE)
     { return ""; }
  else
     { return "Invalid"; }
} 
?>